<?php
namespace Factory;

use Teknisa\Model\Geral\Entities\OperadorAcesso as OperadorAcessoEntity;
use Util\InstanceProvider;
use Teknisa\Libs\Util\NewCode;

class OperadorAcesso {

    /**
     * @param OperadorAcessoEntity $operadorAcessoParameters
     * @param $productId
     * @param $fingerprint
     * @param $userId
     * @param $orgId
     * @param $dateNow
     * @param $token
     * @param $tokenLifeTime
     * @param $keepConnected
     * @param $connection
     * @return OperadorAcessoEntity
     */

    public function save(OperadorAcessoEntity $operadorAcessoParameters = null, $productId, $fingerprint, $userId, $orgId,
                         $dateNow, $token, $tokenLifeTime, $keepConnected, $connection)
    {
        if(!$operadorAcessoParameters) {
            $operadorAcessoParameters = new OperadorAcessoEntity();
            $newCode    = new NewCode($connection, 'NOVO_CODIGO_SC');
            $novoCodigo = $newCode->getCodeByTableName("OPERADOR_ACESSO", $orgId, 1, 10, true);
            $operadorAcessoParameters->setId($novoCodigo);
            $operadorAcessoParameters->setDtInclusao($dateNow);
            $operadorAcessoParameters->setNrOrgInclusao($orgId);
            $operadorAcessoParameters->setCdOperInclusao($userId);
        }

        $operadorAcessoParameters->setNrProdutoId($productId);
        $operadorAcessoParameters->setCdOperador($userId);
        $operadorAcessoParameters->setDsChaveUltAcesso($fingerprint);
        $operadorAcessoParameters->setToken($token);
        $operadorAcessoParameters->setNrtempovidatoken($tokenLifeTime);
        $operadorAcessoParameters->setIdmanterconectado($keepConnected);

        $operadorAcessoParameters->setNrOrg($orgId);
        $operadorAcessoParameters->setIdAtivo("S");
        $operadorAcessoParameters->setDtUltAtu($dateNow);
        $operadorAcessoParameters->setNrOrgUltAtu($orgId);
        $operadorAcessoParameters->setCdOperUltAtu($userId);

        return $operadorAcessoParameters;
    }
}
